/************************************************************************/
/* This header describes some useful 		 			*/
/* mouse & keyboard dealing procedure 					*/
/*    Kiselev Y. & E.Podvoysky from ^Z for WROX press book, 1994	*/
/************************************************************************/

#ifndef KEYMOUSE_H
#define KEYMOUSE_H
#include "common.h"

#define	kwF1   0x3b00
#define kwF2   0x3c00
#define kwF3   0x3d00
#define kwF4   0x3e00
#define kwF5   0x3f00
#define kwF6   0x4000
#define kwF7   0x4100
#define kwF8   0x4200
#define kwF9   0x4300
#define kwF10   0x4400

#define kwF11   0x8500
#define kwF12   0x8600


#define kwShiftF1  0x5400
#define kwShiftF2  0x5500
#define kwShiftF3  0x5600
#define kwShiftF4  0x5700
#define kwShiftF5  0x5800
#define kwShiftF6  0x5900
#define kwShiftF7  0x5a00
#define kwShiftF8  0x5b00
#define kwShiftF9  0x5c00

#define kwShiftF10  0x5d00
#define kwShiftF11  0x8700
#define kwShiftF12  0x8800

#define kwEnter   0x1c0d
#define kwSpace  0x3920
#define kwEsc   0x11b
#define kwCtrlBreak   0
#define kwTab  0x0F09
#define kwShiftTab  0x0F00
#define kwBkSp  0x0E08
		// same w/shift
#define kwCtrlBkSp  0x0E7F
#define kwDel  0x5300
#define kwShiftDel  0x532E
#define kwIns  0x5200
#define kwShiftIns  0x5230


#define kwLeft   0x4b00
#define kwRight   0x4d00
#define kwUp   0x4800
#define kwDown   0x5000
#define kwHome   0x4700
#define kwEnd   0x4f00
#define kwPgUp   0x4900
#define kwPgDn   0x5100
#define kwShiftLeft   0x4b34
#define kwShiftRight   0x4d36
#define kwShiftUp   0x4838
#define kwShiftDown   0x5032
#define kwShiftHome   0x4737
#define kwShiftEnd   0x4f31
#define kwShiftPgUp   0x4939
#define kwShiftPgDn   0x5133

#define kwCtrlLeft  0x7300
#define kwCtrlRight  0x7400
#define kwCtrlHome  0x7700
#define kwCtrlEnd  0x7500

#define kwGreyPlus  0x4e2b
#define kwGreyMinus  0x4a2d
#define kwGreyAsterisk  0x372A


#define kwCtrlPgUp   0x8400
#define kwCtrlPgDn   0x7600
#define kwCtrlLeftSqBracket  1
#define kwCtrlRightSqBracket 2

#define kwAltA   0x1E00
#define kwAltN  0x3100
#define kwAltB   0x3000
#define kwAltO  0x1800
#define kwAltC   0x2E00
#define kwAltP  0x1900
#define kwAltD   0x2000
#define kwAltQ  0x1000
#define kwAltE   0x1200
#define kwAltR  0x1300
#define kwAltF   0x2100
#define kwAltS  0x1F00
#define kwAltG   0x2200
#define kwAltT  0x1400
#define kwAltH   0x2300
#define kwAltU  0x1600
#define kwAltI   0x1700
#define kwAltV  0x2F00
#define kwAltJ   0x2400
#define kwAltW  0x1100
#define kwAltK   0x2500
#define kwAltX  0x2D00
#define kwAltL   0x2600
#define kwAltY  0x1500
#define kwAltM   0x3200
#define kwAltZ  0x2C00

#define kwAlt0   0x8100
#define kwAlt1   0x7800
#define kwAlt2   0x7900
#define kwAlt3   0x7A00
#define kwAlt4   0x7B00
#define kwAlt5   0x7C00
#define kwAlt6   0x7D00
#define kwAlt7   0x7E00
#define kwAlt8   0x7F00
#define kwAlt9   0x8000
#define kwAltF3  0x6A00

#define kwCtrlBkSlash  0x2B1C
#define kwCtrlEnter  0x1c0a

#define kwCtrlA  0x1E01
#define kwCtrlB  0x3002
#define kwCtrlC  0x2E03
#define kwCtrlD  0x2004
#define kwCtrlE  0x1205
#define kwCtrlF  0x2106
#define kwCtrlG  0x2207
#define kwCtrlH  0x2308
#define kwCtrlI  0x1709
#define kwCtrlJ  0x240A
#define kwCtrlK  0x250B
#define kwCtrlL  0x260C
#define kwCtrlM  0x320D
#define kwCtrlN  0x310E
#define kwCtrlO  0x180F
#define kwCtrlP  0x1910
#define kwCtrlQ  0x1011
#define kwCtrlR  0x1312
#define kwCtrlS  0x1F13
#define kwCtrlT  0x1414
#define kwCtrlU  0x1615
#define kwCtrlV  0x2F16
#define kwCtrlW  0x1117
#define kwCtrlX  0x2d18
#define kwCtrlY  0x1519
#define kwCtrlZ  0x2C1A

WORD readkeyword();   // wait key heat and read key value as word
BYTE keyboardstatus();

/////////////////////////////////////////////////////////////////

extern int num_of_buttom;
extern int mousex,mousey;
extern WORD buttons;

int initmouse();
void hide_mouse();
void show_mouse();
void hide_mymouse();
void show_mymouse();
BYTE getmousedata(int &x,int &y);   // where is mouse ?
void setmousepos(int x,int y);
void setmouserange(int x1,int y1,int x2,int y2);
void setmousehandler(void far *handle,WORD mask);
void far mousehandler();

void getmousestate(int &x,int &y,WORD &button);
	// waits mouse button pressed
	// returns mouse coordinates and button code

void initmouse_easy(); // sets mouse handler

void delay_key(long time); // wait kbhit() or mouse button pressed
			   // or time (ms) passed
void clearkey();           // clear keyboard buffer
void delay_key1(long time); // clearkey(); delay_key(time);


#endif
